<!-- 样品列表 -->
<script lang="ts" setup name="SampleList">
import { getCurrentInstance, ref } from 'vue'
import type { Ref } from 'vue'
import type { DateModelType } from 'element-plus'
import { ElLoading, ElMessage, ElMessageBox } from 'element-plus'
import type { ISampleList, ISampleListQuery } from './sample_list_interface'
import type { TableColumn } from '@/components/NormalTable/table_interface'
import { printJSON } from '@/utils/printUtils'
import { exportFile } from '@/utils/exportUtils'
import useTemplateDownload from '@/utils/useTemplateDownload'
import { batchImportSample, deleteSample, exportSapmleList, getSampleList } from '@/api/customer/sampleList'
const { proxy } = getCurrentInstance() as any
const $router = useRouter()
// 查询条件
const listQuery: Ref<ISampleListQuery> = ref({
  sampleNo: '', // 样品编号
  sampleName: '', // 样品名称
  sampleModel: '', // 型号
  customerNo: '', // 委托方代码
  customerName: '', // 委托方名称
  startTime: '', // 检定开始时间
  endTime: '', // 检定结束时间
  overtimeStatus: '', // 样品超期状态 1已超期、0未超期、空字符串 已超期+未超期
  offset: 1,
  limit: 20,
})
const timeRange = ref<[DateModelType, DateModelType]>(['', ''])
// 表头
const columns = ref<TableColumn[]>([
  { text: '样品编号', value: 'sampleNo', width: '160', align: 'center' },
  { text: '样品名称', value: 'sampleName', width: '120', align: 'center' },
  { text: '型号', value: 'sampleModel', align: 'center' },
  { text: '出厂编号', value: 'manufacturingNo', align: 'center' },
  { text: '委托方代码', value: 'customerNo', align: 'center', width: '160' },
  { text: '委托方名称', value: 'customerName', align: 'center' },
  { text: '检定周期(月)', value: 'measurePeriod', align: 'center' },
  { text: '上次检定时间', value: 'measureLastTime', align: 'center', width: '180px' },
  { text: '样品状态', value: 'sampleStatusName', align: 'center', width: '80px' },
  {
    text: '证书过期时间',
    value: 'validDeadline',
    align: 'center',
    width: '180px',
    styleFilter: (row: ISampleList) => { return new Date(row.validDeadline as string).getTime() < new Date().getTime() ? 'color: red' : '' },
  },
  // { text: '备注', value: 'remark', align: 'center' },
])
// 表格数据
const list = ref<ISampleList[]>([])
// 总数
const total = ref(0)
// 表格加载状态
const loadingTable = ref(false)
// 选中的内容
const checkoutList = ref<string[]>([])
// 时间变更
watch(timeRange, (val) => {
  if (val) {
    listQuery.value.startTime = `${val[0]}`
    listQuery.value.endTime = `${val[1]}`
  }
  else {
    listQuery.value.startTime = ''
    listQuery.value.endTime = ''
  }
})
// 数据查询
function fetchData(isNowPage = false) {
  loadingTable.value = true
  if (!isNowPage) {
    // 是否显示当前页，否则跳转第一页
    listQuery.value.offset = 1
  }
  // listQuery.value.startTime = timeRange.value[0] as string || ''
  // listQuery.value.endTime = timeRange.value[1] as string || ''
  getSampleList(listQuery.value).then((response) => {
    list.value = response.data.rows
    total.value = parseInt(response.data.total)
    loadingTable.value = false
  })
}

// 多选发生改变时
function handleSelectionChange(e: any) {
  checkoutList.value = e.map((item: { id: string }) => item.id)
}

// 点击编辑/详情
const handleEdit = (row: ISampleList, pageType: 'edit' | 'detail') => {
  $router.push(`/sample/${pageType}/${row.id}`)
}

// 点击删除
const handleDelete = (row: ISampleList) => {
  ElMessageBox.confirm(
    `确认删除${row.customerName}吗？`,
    '提示',
    {
      confirmButtonText: '确认',
      cancelButtonText: '取消',
      type: 'warning',
    },
  )
    .then(() => {
      deleteSample({ id: row.id }).then((res) => {
        if (res.code === 200) {
          ElMessage({
            type: 'success',
            message: '删除成功',
          })
          fetchData(true)
        }
      })
    })
}

// 点击搜索
const searchList = () => {
  fetchData(true)
}

// 点击重置
const clearList = () => {
  listQuery.value = {
    sampleNo: '', // 样品编号
    sampleName: '', // 样品名称
    sampleModel: '', // 型号
    customerNo: '', // 委托方代码
    customerName: '', // 委托方名称
    startTime: '', // 检定开始时间
    endTime: '', // 检定结束时间
    overtimeStatus: '', // 样品超期状态
    offset: 1,
    limit: 20,
  }
  timeRange.value = ['', ''] // 置空筛选时间
  fetchData(true)
}

// 页数发生变化后的操作，可能是页码变化，可能是每页容量变化，此函数必写
const changePage = (val: { size?: number; page?: number }) => {
  if (val && val.size) {
    listQuery.value.limit = val.size
  }
  if (val && val.page) {
    listQuery.value.offset = val.page
  }
  fetchData(true)
}

// 新建样品
const add = () => {
  $router.push('/sample/add')
}

// 导出
const exportAll = () => {
  const loading = ElLoading.service({
    lock: true,
    text: '下载中请稍后',
    background: 'rgba(255, 255, 255, 0.8)',
  })
  if (list.value.length > 0) {
    const params = {
      sampleNo: listQuery.value.sampleNo, // 样品编号
      sampleName: listQuery.value.sampleName, // 样品名称
      sampleModel: listQuery.value.sampleModel, // 型号
      customerNo: listQuery.value.customerNo, // 委托方代码
      customerName: listQuery.value.customerName, // 委托方名称
      startTime: listQuery.value.startTime, // 投诉开始时间
      endTime: listQuery.value.endTime, // 投诉结束时间
      overtimeStatus: listQuery.value.endTime, // 样品超期状态 1已超期、0未超期、空字符串 已超期+未超期
      ids: checkoutList.value,
    }
    exportSapmleList(params).then((res) => {
      const blob = new Blob([res.data])
      exportFile(blob, '样品列表.xlsx')
    })
  }
  else {
    ElMessage.warning('无数据可导出数据')
  }
  loading.close()
}

// 打印列表
function printList() {
  // 打印列
  const properties = columns.value.map((item) => {
    return {
      field: item.value,
      displayName: item.text,
    }
  })
  if (checkoutList.value.length <= 0 && list.value.length > 0) {
    printJSON(list.value, properties, '样品列表')
  }
  else if (checkoutList.value.length > 0) {
    const printList = list.value.filter((item: ISampleList) => checkoutList.value.includes(item.id))
    printJSON(printList, properties, '样品列表')
  }
  else {
    ElMessage.warning('无可打印内容')
  }
}

// -------------------------------------模板下载、批量导入-----------------------------------
// 模板下载
const templateDownload = () => {
  useTemplateDownload('样品库模块')
}
const fileRef = ref() // 文件上传input
const onFileChange = (event: any) => {
  // 原生上传
  // console.log(event.target.files)
  // if (event.target.files[0].type === 'application/pdf') {
  if (event.target.files?.length !== 0) {
    // 创建formdata对象
    const fd = new FormData()
    fd.append('multipartFile', event.target.files[0])
    const loading = ElLoading.service({
      lock: true,
      background: 'rgba(255, 255, 255, 0.8)',
    })
    batchImportSample(fd).then((res) => {
      if (res.code === 200) {
        ElMessage.success('导入成功')
        fetchData(true)
        loading.close()
        event.target.value = ''
      }
      else {
        ElMessage.error(res.message)
      }
    })
  }
//   }
//   else {
//     ElMessage.error('请上传pdf格式')
//   }
}
// 批量导入
const batchImport = () => {
  fileRef.value.click()
}
// --------------------------------------------------------------------------------------------

fetchData(true)
</script>

<template>
  <app-container>
    <search-area
      :need-clear="true"
      @search="searchList" @clear="clearList"
    >
      <search-item>
        <el-input
          v-model.trim="listQuery.sampleNo"
          placeholder="样品编号"
          clearable
        />
      </search-item>
      <search-item>
        <el-input
          v-model.trim="listQuery.sampleName"
          placeholder="样品名称"
          clearable
        />
      </search-item>
      <search-item>
        <el-input
          v-model.trim="listQuery.sampleModel"
          placeholder="型号"
          clearable
        />
      </search-item>
      <search-item>
        <el-input
          v-model.trim="listQuery.customerNo"
          placeholder="委托方代码"
          clearable
        />
      </search-item>
      <search-item>
        <el-input
          v-model.trim="listQuery.customerName"
          placeholder="委托方名称"
          clearable
        />
      </search-item>
      <search-item>
        <search-item>
          <el-date-picker
            v-model="timeRange"
            type="datetimerange"
            range-separator="到"
            format="YYYY-MM-DD HH:mm:ss"
            value-format="YYYY-MM-DD HH:mm:ss"
            start-placeholder="上次检定开始时间"
            end-placeholder="上次检定结束时间"
          />
        </search-item>
      </search-item>
    </search-area>
    <table-container>
      <template #btns-right>
        <icon-button v-if="proxy.hasPerm('/sample/list/import')" icon="icon-import" title="批量导入" type="primary" @click="batchImport" />
        <icon-button v-if="proxy.hasPerm('/sample/list/import')" icon="icon-template" title="模板下载" type="primary" @click="templateDownload" />
        <icon-button v-if="proxy.hasPerm('/sample/list/add')" icon="icon-add" title="新建" type="primary" @click="add" />
        <icon-button v-if="proxy.hasPerm('/sample/list/export')" icon="icon-export" title="导出" type="primary" @click="exportAll" />
        <icon-button v-if="proxy.hasPerm('/sample/list/print')" icon="icon-print" title="打印" type="primary" @click="printList" />
      </template>
      <input v-show="false" ref="fileRef" type="file" accept="*" @change="onFileChange">
      <normal-table
        :data="list" :total="total" :columns="columns" :query="listQuery"
        :list-loading="loadingTable" is-showmulti-select @change="changePage" @multi-select="handleSelectionChange"
      >
        <template #preColumns>
          <el-table-column label="序号" width="55" align="center">
            <template #default="scope">
              {{ (listQuery.offset - 1) * listQuery.limit + scope.$index + 1 }}
            </template>
          </el-table-column>
        </template>
        <template #columns>
          <el-table-column label="操作" align="center" fixed="right" width="120">
            <template #default="{ row }">
              <!-- 有样品状态的不允许编辑 -->
              <el-button
                v-if="proxy.hasPerm('/sample/list/update') && !row.sampleStatusName"
                size="small"
                type="primary"
                link
                @click="handleEdit(row, 'edit')"
              >
                编辑
              </el-button>
              <el-button
                size="small"
                link
                type="primary"
                @click="handleEdit(row, 'detail')"
              >
                详情
              </el-button>
              <!-- 只有无状态的样品才可以删除 -->
              <el-button
                v-if="proxy.hasPerm('/sample/list/delete') && !row.sampleStatusName"
                size="small"
                link
                type="danger"
                :disabled="row.sampleStatus === '3'"
                @click="handleDelete(row)"
              >
                删除
              </el-button>
            </template>
          </el-table-column>
        </template>
      </normal-table>
    </table-container>
  </app-container>
</template>

<style lang="scss" scoped>
// 样式
</style>
